'use strict';

var app = angular.module('buses', ['ngRoute', 'mobile-angular-ui', 'uiGmapgoogle-maps', 'buses.objects']);

app.config(function($routeProvider, uiGmapGoogleMapApiProvider) {
	
	$routeProvider
		.when('/nearest', 	{ controller: 'NearestCtrl', 	templateUrl: 'partials/stops/nearest.html'})
		.when('/favorites', { controller: 'FavoritesCtrl', 	templateUrl: 'partials/stops/favorites.html'})
		.when('/stop/:id', 	{ controller: 'StopDetailCtrl', 		templateUrl: 'partials/stops/stop-detail.html'})

		.when('/search', 	{ controller: 'SearchCtrl', 	templateUrl: 'partials/search.html'})
		.when('/lines', 	{ controller: 'LinesListCtrl', 	templateUrl: 'partials/lines/list.html'})
		.when('/lines/:id/:direction', 
							{ controller: 'LineDetailCtrl', templateUrl: 'partials/lines/line-detail.html'})

		.otherwise({redirectTo: '/nearest'});

	uiGmapGoogleMapApiProvider.configure({
        key: 		'AIzaSyBJzN9dZ6Mib2UQ2w7HKu2NE_sETwAge88',
        v: 			'3.17',
        libraries: 	'weather,geometry,visualization'
    });
});

app.controller('MainCtrl', function($scope) {
});

app.directive("mfFakeActive", [function () {
    return function (scope, elem, attrs) {
        elem.bind('touchstart', function () {
		     $(this).addClass('fake-active');
		}).bind('touchend', function() {
		     $(this).removeClass('fake-active');
		}).bind('touchcancel', function() {
		     $(this).removeClass('fake-active');
		});
    }
}])


app.filter('reverse', function() {
  return function(items) {
  	if (!items) { return items; };
    return items.slice().reverse();
  };
});