'use strict';

var app = angular.module('buses');

app.service('favoritesManager', function() {

	var obj = {};

	obj.add = function(stop) {
		if (!stop) { return false; };

		var favs = get('favorites') || [];
		favs.push(stop);
		set('favorites', favs);
	}

	obj.remove = function(stop) {
		var favs = get('favorites') || [];
		favs = _.filter(favs, function(v) {
			return v && stop.id != v.id;
		});
		set('favorites', favs);
	}

	obj.isFav = function(stop) {
		if (!stop) { return false; };
		var favs = get('favorites') || [];
		return _.findWhere(favs, {id : stop.id}) !== undefined;
	}

	obj.getAlias = function(_stop) {
		if (!_stop) { return null; };

		var favs = get('favorites') || [];

		var stop = _.findWhere(favs, {id : _stop.id});

		if (!stop) {
			return _stop.name;
		};

		return stop.alias || _stop.name;
	}

	obj.list = function() {
		return get('favorites') || [];
	}

	function get(key) {
		if (!localStorage[key]) {
			return null;
		};
		return JSON.parse(localStorage[key]);
	}

	function set(key, val) {
		localStorage[key] = JSON.stringify(val);
	}

	return obj;

});
