'use strict';

var app = angular.module('buses');

app.controller('LinesListCtrl', function($scope, $location, backend, globalState) {

	$scope.gotoLine = function(line, direction) {
		line.direction = direction;
		globalState.selectedLine = line;
		$location.path('/lines/' + line.id + '/' + line.direction)
	}

	function load() {
		NProgress.start();
		backend.getAllLines().then(function(res) {
			NProgress.done();
			$scope.lines = res;
			globalState.allLines = $scope.lines;
		});
	}

	if (globalState.allLines) {
		$scope.lines = globalState.allLines;
	} else {
		load();
	}

	analytics.trackView('All lines');
});

app.controller('LineDetailCtrl', function($scope, $routeParams, $location, backend, globalState, utils) {

	$scope.gotoStop = function(stop) {
		globalState.selectedStop = stop;
		$location.path('/stop/' + stop.id);
	}

	function loadDetail() {
		NProgress.start();
		backend.getLineDetail($routeParams.id).then(function(res) {
			NProgress.done();
			$scope.line = res;
			$scope.line.direction = $routeParams.direction;
			globalState.selectedFullLine = $scope.line;

		});

		backend.getLineStops($routeParams.id, $routeParams.direction).then(function(res) {
			$scope.stops = res;
			globalState.lineStops = $scope.stops;

		});
	}

	$scope.line = globalState.selectedLine && globalState.selectedLine.id == $routeParams.id 
					? globalState.selectedLine
					: null;

	if (globalState.selectedFullLine 
			&& globalState.selectedFullLine.id 		  == $routeParams.id 
			&& globalState.selectedFullLine.direction == $routeParams.direction) {
		$scope.line = globalState.selectedFullLine;

		if (globalState.lineStops) {
			$scope.stops = globalState.lineStops;
		};

	}

	loadDetail();

	analytics.trackView('Line detail');
});
