'use strict';

var objects = angular.module('buses.objects', []);

objects.factory('Stop', function() {
	return function() {
		this.id 		= null;
		this.name 		= null;
		this.alias 		= null;
		this.latitude 	= null;
		this.longitude 	= null;
		this.address  	= null;
		this.lines  	= [];
	}
});

objects.factory('Line', function() {
	return function() {
		this.id 		= null;
		this.name		= null;
		this.headerA	= null;
		this.headerB	= null;
		this.direction	= null;

		this.getTrajectory = function() {
			if (this.direction.toUpperCase() == 'A') {
				return this.headerB + ' - ' + this.headerA;
			} else {
				return this.headerA + ' - ' + this.headerB;
			}
		}
	}
});

objects.factory('Arrival', function() {
	return function() {
		this.timeLeft = null;
		this.lineId 	 = null;

		this.getHumanTimeLeft = function() {
			var minsLeft = Math.floor(this.timeLeft / 60);
			
			if (minsLeft > 20) {
				return '+20m';
			}

			return minsLeft + ' min';
		}

		this.getPercentArrival = function() {
			var minsLeft = Math.floor(this.timeLeft / 60);

			if (minsLeft > 20) {
				return 100;
			} else {
				return (minsLeft * 100) / 20;
			}
		}
		
	}
});
