'use strict';

var app = angular.module('buses');

app.factory('_', function() {
    return window._;
});

app.service('utils', function() {

	var obj = {};

	obj.distance = function(from, to) {

		var lat1 = from.latitude;
		var lon1 = from.longitude;

		var lat2 = to.latitude;
		var lon2 = to.longitude;

		var radlat1 = Math.PI * lat1/180
		var radlat2 = Math.PI * lat2/180
		var radlon1 = Math.PI * lon1/180
		var radlon2 = Math.PI * lon2/180
		var theta = lon1-lon2
		var radtheta = Math.PI * theta/180
		var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
		dist = Math.acos(dist)
		dist = dist * 180/Math.PI
		dist = dist * 60 * 1.1515
		dist = dist * 1.609344;

		dist = Math.round(dist * 1000);
		return dist
	}

	obj.arrayize = function(obj) {
		if (!_.isArray(obj)) {
			obj = [obj];
		};

		return obj;
	}

	return obj;

});

app.service('location', function($q) {
	var obj = {};

	var location;

	obj.getLocation = function() {
		var deferred = $q.defer();
		
		navigator.geolocation.getCurrentPosition(function(position) {
			location = {
				latitude : position.coords.latitude,
				longitude : position.coords.longitude
			}

			// alert(JSON.stringify(location));
			// location.latitude  += 0.009;
			// location.longitude += 0.009;
			deferred.resolve(location);
		}, function(error) {
			// alert('ERROR(' + error.code + '): ' + error.message);

			// console.log(error);
			
			deferred.reject(error);
		});
		return deferred.promise;
	}

	obj.getLastLocation = function() {
		return location;
	}

	return obj;
})

app.service('globalState', function() {
	var obj = {};
	
	return obj;
});